// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIBase.pas' rev: 3.00

#ifndef SMIBaseHPP
#define SMIBaseHPP
#include <Db.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smibase
{
//-- type declarations -------------------------------------------------------
enum TTableTypeImport { teParadox, teDBase, teText, teHTML, teXLS, teWKS, teQuattro, teXML, teAccess 
	};

typedef Set<TTableTypeImport, teParadox, teAccess>  TImportFormatTypes;

enum TSMICharacterSet { csiANSI_WINDOWS, csiASCII_MSDOS };

enum TImportMode { imAppend, imUpdate, imAppendUpdate, imDelete, imCopy };

enum TSMIAction { iaUnknown, iaAdd, iaUpdate, iaDelete };

enum TSMIResult { irUnknown, irExecuted, irCanceled, irFailed };

enum TSMIFieldDelimiter { fdNone, fdCustom, fdTab, fdSemicolon, fdComma, fdSpace };

enum TSMITextQualifier { tqNone, tqCustom, tqQuot, tqApos };

enum TSMIRecordSeparator { rsCustom, rsCRLF, rsCR, rsLF };

typedef SmallString<10>  TSMIAbout;

enum TSMIOption { soShowMessage, soExtendedStatistic };

typedef Set<TSMIOption, soShowMessage, soExtendedStatistic>  TSMIOptions;

typedef void __fastcall (__closure *TBeforeRecordEvent)(System::TObject* Sender, const System::AnsiString 
	Fields, const System::Variant &Values, bool &Accept);

typedef void __fastcall (__closure *TAfterRecordEvent)(System::TObject* Sender, bool &Abort);

typedef void __fastcall (__closure *TGetCellParamsEvent)(System::TObject* Sender, Db::TField* Field, 
	System::Variant &Value);

typedef void __fastcall (__closure *TErrorEvent)(System::TObject* Sender, Sysutils::Exception* Error
	, bool &Abort);

class DELPHICLASS TSMIStatistic;
class PASCALIMPLEMENTATION TSMIStatistic : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FTotalCount;
	int FTotalImported;
	int FTotalAdded;
	int FTotalDeleted;
	int FTotalUpdated;
	int FTotalErrors;
	int FUpdateStep;
	TSMIAction FLastAction;
	TSMIResult FResult;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int TotalCount = {read=FTotalCount, write=FTotalCount, nodefault};
	__property int TotalImported = {read=FTotalImported, write=FTotalImported, stored=false, nodefault}
		;
	__property int TotalAdded = {read=FTotalAdded, write=FTotalAdded, stored=false, nodefault};
	__property int TotalDeleted = {read=FTotalDeleted, write=FTotalDeleted, stored=false, nodefault};
	__property int TotalUpdated = {read=FTotalUpdated, write=FTotalUpdated, stored=false, nodefault};
	__property int TotalErrors = {read=FTotalErrors, write=FTotalErrors, stored=false, nodefault};
	__property int UpdateStep = {read=FUpdateStep, write=FUpdateStep, default=1};
	__property TSMIAction LastAction = {read=FLastAction, write=FLastAction, stored=false, nodefault};
	__property TSMIResult Result = {read=FResult, write=FResult, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMIStatistic(void) { }
	
public:
	/* TObject.Create */ __fastcall TSMIStatistic(void) : Classes::TPersistent() { }
	
};

enum TSMIDateOrder { doMDY, doDMY, doYMD, doYDM, doDYM, doMYD };

class DELPHICLASS TSMIDataFormats;
class PASCALIMPLEMENTATION TSMIDataFormats : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TSMIDateOrder FDateOrder;
	char FDateSeparator;
	char FTimeSeparator;
	bool FFourDigitYear;
	bool FLeadingZerosInDate;
	char FThousandSeparator;
	char FDecimalSeparator;
	System::AnsiString FBooleanTrue;
	System::AnsiString FBooleanFalse;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TSMIDateOrder DateOrder = {read=FDateOrder, write=FDateOrder, default=0};
	__property char DateSeparator = {read=FDateSeparator, write=FDateSeparator, nodefault};
	__property char TimeSeparator = {read=FTimeSeparator, write=FTimeSeparator, nodefault};
	__property bool FourDigitYear = {read=FFourDigitYear, write=FFourDigitYear, nodefault};
	__property bool LeadingZerosInDate = {read=FLeadingZerosInDate, write=FLeadingZerosInDate, nodefault
		};
	__property char ThousandSeparator = {read=FThousandSeparator, write=FThousandSeparator, nodefault};
		
	__property char DecimalSeparator = {read=FDecimalSeparator, write=FDecimalSeparator, nodefault};
	__property System::AnsiString BooleanTrue = {read=FBooleanTrue, write=FBooleanTrue};
	__property System::AnsiString BooleanFalse = {read=FBooleanFalse, write=FBooleanFalse};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMIDataFormats(void) { }
	
public:
	/* TObject.Create */ __fastcall TSMIDataFormats(void) : Classes::TPersistent() { }
	
};

class DELPHICLASS TSMImportBaseComponent;
class PASCALIMPLEMENTATION TSMImportBaseComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TSMIAbout FAbout;
	bool FAnimatedStatus;
	Db::TDataSet* FDataSet;
	System::AnsiString FDatasetKeys;
	Classes::TStrings* FMappings;
	TImportMode FMode;
	TSMIOptions FOptions;
	System::AnsiString FTitleStatus;
	TSMIFieldDelimiter FFieldDelimiter;
	char FFieldDelimiterCustom;
	TSMITextQualifier FTextQualifier;
	char FTextQualifierCustom;
	TSMIRecordSeparator FRecordSeparator;
	System::AnsiString FRecordSeparatorCustom;
	bool FFixed;
	System::AnsiString FSourceFileName;
	int FRowFirst;
	int FRowLast;
	TSMICharacterSet FCharacterSet;
	TSMIDataFormats* FDataFormats;
	TTableTypeImport FTableType;
	TErrorEvent FOnErrorEvent;
	TGetCellParamsEvent FOnGetCellParams;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	TBeforeRecordEvent FOnBeforeRecordEvent;
	TAfterRecordEvent FOnAfterRecordEvent;
	Classes::TNotifyEvent FOnBeforeUpdate;
	Classes::TNotifyEvent FOnBeforeLoadSpecification;
	Classes::TNotifyEvent FOnAfterLoadSpecification;
	Classes::TNotifyEvent FOnBeforeSaveSpecification;
	Classes::TNotifyEvent FOnAfterSaveSpecification;
	bool IsFound;
	bool Abort;
	TSMIStatistic* FStatistic;
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	void __fastcall SetMappings(Classes::TStrings* AValue);
	System::AnsiString __fastcall Translate(const System::AnsiString s, bool IsEncrypt);
	
protected:
	System::Variant vLocate;
	System::Variant vValues;
	System::Variant vFields;
	int __fastcall GetFieldItem(const System::AnsiString FieldName);
	System::AnsiString __fastcall GetTableName();
	bool __fastcall IsGoodRow(int i);
	virtual void __fastcall Prepare(void);
	virtual void __fastcall BeforeImport(void);
	virtual void __fastcall AfterImport(void);
	virtual void __fastcall BuildArrayIntersection(void);
	virtual void __fastcall BuildFieldMapping(void);
	virtual bool __fastcall LoadRecord(void);
	virtual void __fastcall GoFirst(void);
	virtual void __fastcall GoNext(void);
	virtual bool __fastcall NeedMore(void);
	virtual int __fastcall GetTotalCount(void);
	virtual System::Variant __fastcall GetValues(const System::AnsiString strValues);
	virtual System::Variant __fastcall GetFieldValue(const System::Variant &v);
	virtual System::Variant __fastcall GetParsedValue(const System::Variant &v, int intFieldIndex);
	virtual bool __fastcall FieldIsTruncated(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual bool __fastcall NotDefined(System::AnsiString &strProperty);
	System::AnsiString __fastcall GetKeyList(Db::TDataSet* DS);
	void __fastcall FillKey4Locate(void);
	void __fastcall FillKey4Values(void);
	void __fastcall SetFieldDelimiter(TSMIFieldDelimiter Value);
	void __fastcall SetFieldDelimiterCustom(char Value);
	void __fastcall SetTextQualifier(TSMITextQualifier Value);
	void __fastcall SetTextQualifierCustom(char Value);
	void __fastcall SetRecordSeparator(TSMIRecordSeparator Value);
	void __fastcall SetRecordSeparatorCustom(System::AnsiString Value);
	__property TTableTypeImport TableType = {read=FTableType, write=FTableType, default=2};
	
public:
	__fastcall virtual TSMImportBaseComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMImportBaseComponent(void);
	void __fastcall Execute(void);
	void __fastcall AboutSMI(void);
	/* virtual class method */ virtual System::AnsiString __fastcall Extension() { Extension(__classid(TSMImportBaseComponent)
		); }
	/*         class method */ static System::AnsiString __fastcall Extension(System::TMetaClass* vmt);
		
	/* virtual class method */ virtual System::AnsiString __fastcall FillFileFilters() { FillFileFilters(__classid(TSMImportBaseComponent)
		); }
	/*         class method */ static System::AnsiString __fastcall FillFileFilters(System::TMetaClass* vmt
		);
	virtual void __fastcall DetectAutoMapping(void);
	void __fastcall LoadSpecification(System::AnsiString strFileName);
	void __fastcall SaveSpecification(System::AnsiString SpecName, System::AnsiString FileName, bool ShowDialog
		);
	__property TSMIFieldDelimiter FieldDelimiter = {read=FFieldDelimiter, write=SetFieldDelimiter, default=2
		};
	__property char FieldDelimiterCustom = {read=FFieldDelimiterCustom, write=SetFieldDelimiterCustom, 
		default=9};
	__property TSMITextQualifier TextQualifier = {read=FTextQualifier, write=SetTextQualifier, default=2
		};
	__property char TextQualifierCustom = {read=FTextQualifierCustom, write=SetTextQualifierCustom, default=34
		};
	__property TSMIRecordSeparator RecordSeparator = {read=FRecordSeparator, write=SetRecordSeparator, 
		default=1};
	__property System::AnsiString RecordSeparatorCustom = {read=FRecordSeparatorCustom, write=SetRecordSeparatorCustom
		};
	__property System::AnsiString SourceFileName = {read=FSourceFileName, write=FSourceFileName};
	__property bool Fixed = {read=FFixed, write=FFixed, nodefault};
	__property int RowFirst = {read=FRowFirst, write=FRowFirst, default=1};
	__property int RowLast = {read=FRowLast, write=FRowLast, default=2147483647};
	
__published:
	__property TSMIAbout About = {read=FAbout, write=FAbout};
	__property bool AnimatedStatus = {read=FAnimatedStatus, write=FAnimatedStatus, nodefault};
	__property TSMICharacterSet CharacterSet = {read=FCharacterSet, write=FCharacterSet, default=0};
	__property TSMIDataFormats* DataFormats = {read=FDataFormats, write=FDataFormats};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property System::AnsiString DatasetKeys = {read=FDatasetKeys, write=FDatasetKeys};
	__property Classes::TStrings* Mappings = {read=FMappings, write=SetMappings};
	__property TImportMode Mode = {read=FMode, write=FMode, default=0};
	__property TSMIOptions Options = {read=FOptions, write=FOptions, default=3};
	__property System::AnsiString TitleStatus = {read=FTitleStatus, write=FTitleStatus};
	__property TSMIStatistic* Statistic = {read=FStatistic, write=FStatistic};
	__property TErrorEvent OnErrorEvent = {read=FOnErrorEvent, write=FOnErrorEvent};
	__property TGetCellParamsEvent OnGetCellParams = {read=FOnGetCellParams, write=FOnGetCellParams};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
		
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property TBeforeRecordEvent OnBeforeRecordEvent = {read=FOnBeforeRecordEvent, write=FOnBeforeRecordEvent
		};
	__property TAfterRecordEvent OnAfterRecordEvent = {read=FOnAfterRecordEvent, write=FOnAfterRecordEvent
		};
	__property Classes::TNotifyEvent OnBeforeUpdate = {read=FOnBeforeUpdate, write=FOnBeforeUpdate};
	__property Classes::TNotifyEvent OnBeforeLoadSpecification = {read=FOnBeforeLoadSpecification, write=
		FOnBeforeLoadSpecification};
	__property Classes::TNotifyEvent OnAfterLoadSpecification = {read=FOnAfterLoadSpecification, write=
		FOnAfterLoadSpecification};
	__property Classes::TNotifyEvent OnBeforeSaveSpecification = {read=FOnBeforeSaveSpecification, write=
		FOnBeforeSaveSpecification};
	__property Classes::TNotifyEvent OnAfterSaveSpecification = {read=FOnAfterSaveSpecification, write=
		FOnAfterSaveSpecification};
};

typedef void __fastcall (*TPreviewCallback)(System::TObject* grid, int intColumnCount, int intRecNo, 
	bool IsASCII, const System::Variant &Value);

//-- var, const, procedure ---------------------------------------------------
#define SMIVersion "1.55"
#define MaxRowValue (int)(2147483647)
extern PACKAGE void __fastcall AboutSMImport(void);
extern PACKAGE System::ShortString __fastcall GetDefExt(int intIndex);
extern PACKAGE System::AnsiString __fastcall UECode(bool DOSToWin, System::AnsiString St);

}	/* namespace Smibase */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smibase;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMIBase
