// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMCells.pas' rev: 6.00

#ifndef SMCellsHPP
#define SMCellsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SMIBase.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smcells
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TOnColumnWidth)(System::TObject* Sender, int SheetIndex, int ColumnNo, int Width);

typedef void __fastcall (__closure *TOnRowHeight)(System::TObject* Sender, int SheetIndex, int RowNo, int Height);

typedef void __fastcall (__closure *TOnDimensions)(System::TObject* Sender, int SheetIndex, int FirstRow, int LastRow, int FirstColumn, int LastColumn);

typedef void __fastcall (__closure *TOnCellValue)(System::TObject* Sender, int SheetIndex, int Row, int Column, const Variant &Value, Classes::TAlignment Alignment);

typedef void __fastcall (__closure *TOnSheet)(System::TObject* Sender, AnsiString Caption, int Index, bool &Skip);

typedef Variant TSpreadSheetCols[256];

struct TSpreadSheetRow;
typedef TSpreadSheetRow *PSpreadSheetRow;

struct TSpreadSheetRow
{
	int Index;
	Variant Cols[256];
	Variant Alignments[256];
} ;

class DELPHICLASS TSpreadSheetCells;
class PASCALIMPLEMENTATION TSpreadSheetCells : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	Word FColCount;
	Word FRowCount;
	Word FUsedColCount;
	Word FUsedRowCount;
	
public:
	__fastcall virtual ~TSpreadSheetCells(void);
	int __fastcall AddRow(int i);
	int __fastcall GetRow(int Row, bool NeedAdd);
	void __fastcall RemoveRow(int i);
	virtual void __fastcall Clear(void);
	Classes::TAlignment __fastcall GetAlignment(int Col, int Row);
	Variant __fastcall GetValue(int Col, int Row);
	void __fastcall SetValue(int Col, int Row, const Variant &Value, Classes::TAlignment Alignment);
	__property Word UsedColCount = {read=FUsedColCount, nodefault};
	__property Word UsedRowCount = {read=FUsedRowCount, nodefault};
	__property Word ColCount = {read=FColCount, write=FColCount, nodefault};
	__property Word RowCount = {read=FRowCount, write=FRowCount, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSpreadSheetCells(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS TSpreadSheet;
class PASCALIMPLEMENTATION TSpreadSheet : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
public:
	TSpreadSheetCells* Cells;
	AnsiString Caption;
	__fastcall virtual TSpreadSheet(void);
	__fastcall virtual ~TSpreadSheet(void);
};


class DELPHICLASS TSpreadSheets;
class PASCALIMPLEMENTATION TSpreadSheets : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TSpreadSheets(void);
	HIDESBASE int __fastcall Add(void);
	HIDESBASE void __fastcall Remove(int Index);
	virtual void __fastcall Clear(void);
	TSpreadSheet* __fastcall Spreadsheet(int Index);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSpreadSheets(void) : Classes::TList() { }
	#pragma option pop
	
};


class DELPHICLASS TCustomSpreadSheetFile;
class PASCALIMPLEMENTATION TCustomSpreadSheetFile : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FFileName;
	TOnColumnWidth FOnColumnWidth;
	TOnRowHeight FOnRowHeight;
	TOnDimensions FOnDimensions;
	TOnCellValue FOnCellValue;
	TOnSheet FOnSheet;
	
__published:
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property TOnColumnWidth OnColumnWidth = {read=FOnColumnWidth, write=FOnColumnWidth};
	__property TOnRowHeight OnRowHeight = {read=FOnRowHeight, write=FOnRowHeight};
	__property TOnDimensions OnDimensions = {read=FOnDimensions, write=FOnDimensions};
	__property TOnCellValue OnCellValue = {read=FOnCellValue, write=FOnCellValue};
	__property TOnSheet OnSheet = {read=FOnSheet, write=FOnSheet};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TCustomSpreadSheetFile(Classes::TComponent* AOwner) : Classes::TComponent(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TCustomSpreadSheetFile(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSpreadSheetFile;
class PASCALIMPLEMENTATION TSpreadSheetFile : public TCustomSpreadSheetFile 
{
	typedef TCustomSpreadSheetFile inherited;
	
private:
	void __fastcall DimsEvent(System::TObject* Sender, int SheetIndex, int FirstRow, int LastRow, int FirstColumn, int LastColumn);
	void __fastcall CellEvent(System::TObject* Sender, int SheetIndex, int Row, int Column, const Variant &Value, Classes::TAlignment Alignment);
	void __fastcall SheetEvent(System::TObject* Sender, AnsiString Caption, int Index, bool &Skip);
	
protected:
	Word BufferHeader[2];
	
public:
	TSpreadSheets* Sheets;
	__fastcall virtual TSpreadSheetFile(Classes::TComponent* AOwner);
	__fastcall virtual ~TSpreadSheetFile(void);
	virtual void __fastcall LoadFromFile(const AnsiString FileName);
};


//-- var, const, procedure ---------------------------------------------------
static const Word MAXRow = 0xffff;
static const Byte MAXCol = 0xff;

}	/* namespace Smcells */
using namespace Smcells;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMCells
