// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIBase.pas' rev: 6.00

#ifndef SMIBaseHPP
#define SMIBaseHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <DB.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Buttons.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smibase
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTableTypeImport { teParadox, teDBase, teText, teHTML, teXLS, teWKS, teQuattro, teXML, teAccess };
#pragma option pop

typedef Set<TTableTypeImport, teParadox, teAccess>  TImportFormatTypes;

#pragma option push -b-
enum TSMICharacterSet { csiANSI_WINDOWS, csiASCII_MSDOS };
#pragma option pop

#pragma option push -b-
enum TImportMode { imAppend, imUpdate, imAppendUpdate, imDelete, imCopy };
#pragma option pop

#pragma option push -b-
enum TSMIAction { iaUnknown, iaAdd, iaUpdate, iaDelete };
#pragma option pop

#pragma option push -b-
enum TSMIResult { irUnknown, irExecuted, irCanceled, irFailed };
#pragma option pop

#pragma option push -b-
enum TSMIFieldDelimiter { fdNone, fdCustom, fdTab, fdSemicolon, fdComma, fdSpace };
#pragma option pop

#pragma option push -b-
enum TSMITextQualifier { tqNone, tqCustom, tqQuot, tqApos };
#pragma option pop

#pragma option push -b-
enum TSMIRecordSeparator { rsCustom, rsCRLF, rsCR, rsLF };
#pragma option pop

typedef SmallString<10>  TSMIAbout;

#pragma option push -b-
enum TSMIOption { soShowMessage, soExtendedStatistic };
#pragma option pop

typedef Set<TSMIOption, soShowMessage, soExtendedStatistic>  TSMIOptions;

typedef void __fastcall (__closure *TBeforeRecordEvent)(System::TObject* Sender, const AnsiString Fields, const Variant &Values, bool &Accept);

typedef void __fastcall (__closure *TAfterRecordEvent)(System::TObject* Sender, bool &Abort);

typedef void __fastcall (__closure *TGetCellParamsEvent)(System::TObject* Sender, Db::TField* Field, Variant &Value);

typedef void __fastcall (__closure *TErrorEvent)(System::TObject* Sender, Sysutils::Exception* Error, bool &Abort);

class DELPHICLASS TSMIStatistic;
class PASCALIMPLEMENTATION TSMIStatistic : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FTotalCount;
	int FTotalImported;
	int FTotalAdded;
	int FTotalDeleted;
	int FTotalUpdated;
	int FTotalErrors;
	int FUpdateStep;
	TSMIAction FLastAction;
	TSMIResult FResult;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property int TotalCount = {read=FTotalCount, write=FTotalCount, nodefault};
	__property int TotalImported = {read=FTotalImported, write=FTotalImported, stored=false, nodefault};
	__property int TotalAdded = {read=FTotalAdded, write=FTotalAdded, stored=false, nodefault};
	__property int TotalDeleted = {read=FTotalDeleted, write=FTotalDeleted, stored=false, nodefault};
	__property int TotalUpdated = {read=FTotalUpdated, write=FTotalUpdated, stored=false, nodefault};
	__property int TotalErrors = {read=FTotalErrors, write=FTotalErrors, stored=false, nodefault};
	__property int UpdateStep = {read=FUpdateStep, write=FUpdateStep, default=1};
	__property TSMIAction LastAction = {read=FLastAction, write=FLastAction, stored=false, nodefault};
	__property TSMIResult Result = {read=FResult, write=FResult, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMIStatistic(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMIStatistic(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TSMIDateOrder { doMDY, doDMY, doYMD, doYDM, doDYM, doMYD };
#pragma option pop

class DELPHICLASS TSMIDataFormats;
class PASCALIMPLEMENTATION TSMIDataFormats : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TSMIDateOrder FDateOrder;
	char FDateSeparator;
	char FTimeSeparator;
	bool FFourDigitYear;
	bool FLeadingZerosInDate;
	char FThousandSeparator;
	char FDecimalSeparator;
	AnsiString FBooleanTrue;
	AnsiString FBooleanFalse;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TSMIDateOrder DateOrder = {read=FDateOrder, write=FDateOrder, default=0};
	__property char DateSeparator = {read=FDateSeparator, write=FDateSeparator, nodefault};
	__property char TimeSeparator = {read=FTimeSeparator, write=FTimeSeparator, nodefault};
	__property bool FourDigitYear = {read=FFourDigitYear, write=FFourDigitYear, nodefault};
	__property bool LeadingZerosInDate = {read=FLeadingZerosInDate, write=FLeadingZerosInDate, nodefault};
	__property char ThousandSeparator = {read=FThousandSeparator, write=FThousandSeparator, nodefault};
	__property char DecimalSeparator = {read=FDecimalSeparator, write=FDecimalSeparator, nodefault};
	__property AnsiString BooleanTrue = {read=FBooleanTrue, write=FBooleanTrue};
	__property AnsiString BooleanFalse = {read=FBooleanFalse, write=FBooleanFalse};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMIDataFormats(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMIDataFormats(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TSMImportBaseComponent;
class PASCALIMPLEMENTATION TSMImportBaseComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TSMIAbout FAbout;
	bool FAnimatedStatus;
	Db::TDataSet* FDataSet;
	AnsiString FDatasetKeys;
	Classes::TStrings* FMappings;
	TImportMode FMode;
	TSMIOptions FOptions;
	AnsiString FTitleStatus;
	TSMIFieldDelimiter FFieldDelimiter;
	char FFieldDelimiterCustom;
	TSMITextQualifier FTextQualifier;
	char FTextQualifierCustom;
	TSMIRecordSeparator FRecordSeparator;
	AnsiString FRecordSeparatorCustom;
	bool FFixed;
	AnsiString FSourceFileName;
	int FRowFirst;
	int FRowLast;
	TSMICharacterSet FCharacterSet;
	TSMIDataFormats* FDataFormats;
	TTableTypeImport FTableType;
	TErrorEvent FOnErrorEvent;
	TGetCellParamsEvent FOnGetCellParams;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	TBeforeRecordEvent FOnBeforeRecordEvent;
	TAfterRecordEvent FOnAfterRecordEvent;
	Classes::TNotifyEvent FOnBeforeUpdate;
	Classes::TNotifyEvent FOnBeforeLoadSpecification;
	Classes::TNotifyEvent FOnAfterLoadSpecification;
	Classes::TNotifyEvent FOnBeforeSaveSpecification;
	Classes::TNotifyEvent FOnAfterSaveSpecification;
	bool IsFound;
	bool Abort;
	TSMIStatistic* FStatistic;
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	void __fastcall SetMappings(Classes::TStrings* AValue);
	AnsiString __fastcall Translate(const AnsiString s, bool IsEncrypt);
	
protected:
	Variant vLocate;
	Variant vValues;
	Variant vFields;
	int __fastcall GetFieldItem(const AnsiString FieldName);
	AnsiString __fastcall GetTableName();
	bool __fastcall IsGoodRow(int i);
	virtual void __fastcall Prepare(void);
	virtual void __fastcall BeforeImport(void);
	virtual void __fastcall AfterImport(void);
	virtual void __fastcall BuildArrayIntersection(void);
	virtual void __fastcall BuildFieldMapping(void);
	virtual bool __fastcall LoadRecord(void);
	virtual void __fastcall GoFirst(void);
	virtual void __fastcall GoNext(void);
	virtual bool __fastcall NeedMore(void);
	virtual int __fastcall GetTotalCount(void);
	virtual Variant __fastcall GetValues(const AnsiString strValues);
	virtual Variant __fastcall GetFieldValue(const Variant &v);
	virtual Variant __fastcall GetParsedValue(const Variant &v, int intFieldIndex);
	virtual bool __fastcall FieldIsTruncated(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual bool __fastcall NotDefined(AnsiString &strProperty);
	AnsiString __fastcall GetKeyList(Db::TDataSet* DS);
	void __fastcall FillKey4Locate(void);
	void __fastcall FillKey4Values(void);
	void __fastcall SetFieldDelimiter(TSMIFieldDelimiter Value);
	void __fastcall SetFieldDelimiterCustom(char Value);
	void __fastcall SetTextQualifier(TSMITextQualifier Value);
	void __fastcall SetTextQualifierCustom(char Value);
	void __fastcall SetRecordSeparator(TSMIRecordSeparator Value);
	void __fastcall SetRecordSeparatorCustom(AnsiString Value);
	__property TTableTypeImport TableType = {read=FTableType, write=FTableType, default=2};
	
public:
	__fastcall virtual TSMImportBaseComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMImportBaseComponent(void);
	void __fastcall Execute(void);
	void __fastcall AboutSMI(void);
	/* virtual class method */ virtual AnsiString __fastcall Extension(TMetaClass* vmt);
	/* virtual class method */ virtual AnsiString __fastcall FillFileFilters(TMetaClass* vmt);
	virtual void __fastcall DetectAutoMapping(void);
	void __fastcall LoadSpecification(AnsiString strFileName);
	void __fastcall SaveSpecification(AnsiString SpecName, AnsiString FileName, bool ShowDialog);
	__property TSMIFieldDelimiter FieldDelimiter = {read=FFieldDelimiter, write=SetFieldDelimiter, default=2};
	__property char FieldDelimiterCustom = {read=FFieldDelimiterCustom, write=SetFieldDelimiterCustom, default=9};
	__property TSMITextQualifier TextQualifier = {read=FTextQualifier, write=SetTextQualifier, default=2};
	__property char TextQualifierCustom = {read=FTextQualifierCustom, write=SetTextQualifierCustom, default=34};
	__property TSMIRecordSeparator RecordSeparator = {read=FRecordSeparator, write=SetRecordSeparator, default=1};
	__property AnsiString RecordSeparatorCustom = {read=FRecordSeparatorCustom, write=SetRecordSeparatorCustom};
	__property AnsiString SourceFileName = {read=FSourceFileName, write=FSourceFileName};
	__property bool Fixed = {read=FFixed, write=FFixed, nodefault};
	__property int RowFirst = {read=FRowFirst, write=FRowFirst, default=1};
	__property int RowLast = {read=FRowLast, write=FRowLast, default=2147483647};
	
__published:
	__property TSMIAbout About = {read=FAbout, write=FAbout};
	__property bool AnimatedStatus = {read=FAnimatedStatus, write=FAnimatedStatus, nodefault};
	__property TSMICharacterSet CharacterSet = {read=FCharacterSet, write=FCharacterSet, default=0};
	__property TSMIDataFormats* DataFormats = {read=FDataFormats, write=FDataFormats};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property AnsiString DatasetKeys = {read=FDatasetKeys, write=FDatasetKeys};
	__property Classes::TStrings* Mappings = {read=FMappings, write=SetMappings};
	__property TImportMode Mode = {read=FMode, write=FMode, default=0};
	__property TSMIOptions Options = {read=FOptions, write=FOptions, default=3};
	__property AnsiString TitleStatus = {read=FTitleStatus, write=FTitleStatus};
	__property TSMIStatistic* Statistic = {read=FStatistic, write=FStatistic};
	__property TErrorEvent OnErrorEvent = {read=FOnErrorEvent, write=FOnErrorEvent};
	__property TGetCellParamsEvent OnGetCellParams = {read=FOnGetCellParams, write=FOnGetCellParams};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property TBeforeRecordEvent OnBeforeRecordEvent = {read=FOnBeforeRecordEvent, write=FOnBeforeRecordEvent};
	__property TAfterRecordEvent OnAfterRecordEvent = {read=FOnAfterRecordEvent, write=FOnAfterRecordEvent};
	__property Classes::TNotifyEvent OnBeforeUpdate = {read=FOnBeforeUpdate, write=FOnBeforeUpdate};
	__property Classes::TNotifyEvent OnBeforeLoadSpecification = {read=FOnBeforeLoadSpecification, write=FOnBeforeLoadSpecification};
	__property Classes::TNotifyEvent OnAfterLoadSpecification = {read=FOnAfterLoadSpecification, write=FOnAfterLoadSpecification};
	__property Classes::TNotifyEvent OnBeforeSaveSpecification = {read=FOnBeforeSaveSpecification, write=FOnBeforeSaveSpecification};
	__property Classes::TNotifyEvent OnAfterSaveSpecification = {read=FOnAfterSaveSpecification, write=FOnAfterSaveSpecification};
};


typedef void __fastcall (*TPreviewCallback)(System::TObject* grid, int intColumnCount, int intRecNo, bool IsASCII, const Variant &Value);

//-- var, const, procedure ---------------------------------------------------
#define SMIVersion "1.55"
static const int MaxRowValue = 0x7fffffff;
extern PACKAGE void __fastcall AboutSMImport(void);
extern PACKAGE System::ShortString __fastcall GetDefExt(int intIndex);
extern PACKAGE AnsiString __fastcall UECode(bool DOSToWin, AnsiString St);

}	/* namespace Smibase */
using namespace Smibase;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMIBase
